Codeforces 671B 二分

    xiaoxiao2021-03-26  17

    Robin Hood time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output

    We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

    There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people.

    After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

    Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn't affect the answer.

    Input

    The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

    The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

    Output

    Print a single line containing the difference between richest and poorest peoples wealth.

    Examples input 4 1 1 1 4 2 output 2 input 3 1 2 2 2 output 0 Note

    Lets look at how wealth changes through day in the first sample.

    [1, 1, 4, 2] [2, 1, 3, 2] or [1, 2, 3, 2]

    So the answer is 3 - 1 = 2

    In second sample wealth will remain the same for each person.

    题意:n个人,每个人ci的金币,每天最富有的人都会给最贫穷的人1金币,问k天后最富有人和最贫穷的人差了多少金币。

    题解:

    假设每天最多金币的一人减少一个金币  不翼而飞  二分出金币的最大值

    同理计算出最小值

    如果最小值大于等于最大值  就代表进入了循环状态  最大最小相差小于1  所以判断一下sum是否能整除n  如果能  答案是0  否则是1

    如果不大于  就直接输出最大值最小值

    二分的方法是:对于一个mid  我们求出至少有一个金币是mid+1的天数是多少  至少有一个金币为mid-1的天数是多少

    那么只要判断k是否在这个区间即可

    #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> using namespace std; typedef long long ll; ll a[500005],k,n; ll check(ll t){ ll num1=0,num2=0; for(ll i=1;i<=n;i++){ num1+=max(a[i]-(t),0LL); num2+=max(a[i]-(t-1),0LL); } num1--; if(num1<k&&num2>k)return 1; if(num1>=k)return -1; if(num2<=k)return 0; } ll checks(ll t){ ll num1=0,num2=0; for(ll i=1;i<=n;i++){ num1+=max((t)-a[i],0LL); num2+=max((t+1)-a[i],0LL); } num1--; if(num1<k&&num2>k)return 1; if(num1>=k)return -1; if(num2<=k)return 0; } int main(){ ll i; scanf("%lld%lld",&n,&k); ll da=0,xiao=1000000,sum=0; for(i=1;i<=n;i++)scanf("%lld",&a[i]),da=max(da,a[i]),xiao=min(xiao,a[i]),sum+=a[i]; ll l=xiao,r=da; ll mas; while(l+1<r){ ll mid=(l+r)/2; ll d=check(mid); if(d==1){ r=mid; break; } if(d==-1)l=mid; else r=mid; } if(check(r))mas=r; else mas=l; l=xiao; r=da; while(l+1<r){ ll mid=(l+r)/2; ll d=checks(mid); if(d==1){ l=mid; break; } if(d==-1)r=mid; else l=mid; } ll o; if(check(l))o=l; else o=r; if(o>=mas){ if(sum%n)printf("1\n"); else printf("0\n"); } else printf("%lld\n",mas-o); return 0; }

    转载请注明原文地址: https://ju.6miu.com/read-500406.html

    最新回复(0)